import java.io.*;
import java.lang.*;
import java.util.*;
import java.net.*;

public class listenSocket implements Runnable
{
   private boolean blnRunning;
   private ServerSocket serverSocket ;
   private Socket clientSocket;
   private WebServerFrame frame;
   private String linesep;

   // Constructor
   public listenSocket(ServerSocket serverSocket, WebServerFrame frame)
   {
      this.serverSocket = serverSocket;
      this.frame = frame;

      // Line Separator
      linesep = System.getProperty("line.separator");

      // Run the main thread of Web Server
      Thread thread = new Thread(this);
      thread.start();
   }

   // Set Server to run
   public void setRunning(boolean isRunning)
   {
      blnRunning = isRunning;
   }

   // Check Server if running
   public boolean getRunning()
   {
      return blnRunning;
   }

   // run thread
   public void run()
   {
      while (true)
      {
	 if (blnRunning)
	 {
	    try
	    {
	       // Listen this socket
	       Socket clientSocket = serverSocket.accept();

	       String sMsg = "HTTP Request from " + clientSocket.getInetAddress().getHostAddress() ;
	       frame.txtLog.append(sMsg + linesep);
	       frame.txtLog.setCaretPosition(frame.txtLog.getText().length());
	       System.out.println(sMsg);

	       // A connection is accepted
	       // Fork a HTTP Session and run this thread
	       Thread thread = new Thread(new HTTPSession(clientSocket, frame));
	       thread.start();
	    }
	    catch (Exception ex)
	    {
	       // Log exception message
	       frame.txtLog.append(ex.getMessage() + linesep);
	       frame.txtLog.setCaretPosition(frame.txtLog.getText().length());
	       System.out.println(ex.getMessage());
	    }
	 }
	 try
	 {
	    Thread.sleep(500);
	 }
	 catch (Exception ex) {}
      }
   }
}
